/* 
 *    Programmed By: Mohammed Isam Mohammed [mohammed_isam1984@yahoo.com]
 *    Copyright 2014, 2015 (c)
 * 
 *    file: defs.h
 *    This file is part of the GBall project.
 *
 *    GBall is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    GBall is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with GBall.  If not, see <http://www.gnu.org/licenses/>.
 */    

#ifndef __G_BALL
#define __G_BALL

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <pwd.h>
#include <console/dialogs.h>

typedef enum
{ UP_LEFT = 1, UP_RIGHT, DOWN_LEFT, DOWN_RIGHT }
direction_e;

#define BRICK_WALL		'        '
#define BRICK_1		BGRED		//41
#define BRICK_2		BGGREEN
#define BRICK_3		BGBROWN
#define BRICK_4		BGBLUE
#define BRICK_5		BGMAGENTA
#define BRICK_6		BGCYAN
#define BRICK_7		BGWHITE		//47

#define MAX_LENGTH		100
#define MAX_LEVEL		9

#define BASE_SPEED		50000
#define MAX_SPEED		10000
#define MIN_SPEED		100000
#define SPEED_STEP		5000

#define DEFAULT_MAX_SCORE	10

typedef struct
{
  int x, y;				//position of racket
  int length;				//racket length
  int dy;				//how many columns to move
} racket_s;
racket_s racket;

typedef struct
{
  int x, y;
  int old_x, old_y;
  direction_e direction;
  int speed;
} ball_s;
ball_s ball;

int LEVEL;
int score;
int level_score;

int blocks_per_line;
int total_block_lines;
int line_start;
int total_bricks;

struct passwd *pass;//will be used to find the home dir

#endif /* __G_BALL */